module PolyglotFlutter
  module Resource
    class TranslationKey < Base
      def clean_translation(language)
        translation_value = name
        translation = translations.find { |key| key.language.id == language.id }
        translation_value = translation.value if translation&.value
        escape_translation(translation_value)
        if translation_value.include? '%'
          translation_value = convert_aruments(translation_value)
        end
        translation_value
      end

      private

      def escape_translation(translation)
        translation
          .gsub('"', '\\"')
      end

      def convert_aruments(translation)
        new_translation = translation
        translation.scan(/(%\w)/).each_with_index do |match, index|
          new_translation = new_translation.sub(match[0], '{arg' + String(index) + '}')
        end

        new_translation
      end
    end
  end
end
