module PolyglotFlutter
  module Command
    class Login
      include Helper::Terminal

      def self.init
        new.call
      end

      def call
        PolyglotFlutter::IO::Token.write(token)
      end

      private

      def token
        prompt.say('Logging into API...')
        @data = PolyglotFlutter::Resource::Session.create(email: email, password: password)
        @data.token
      end

      def email
        prompt.ask('Email:') { |value| value.validate :email }
      end

      def password
        prompt.mask('Password:')
      end
    end
  end
end
