module PolyglotFlutter
  module Serializer
    module Localization
      class Base
        include ERB::Util
        include Helper::General
        attr_accessor :languages, :translation_keys

        def initialize(languages: nil, translation_keys: nil, mandatory_language: nil)
          @languages = languages
          @translation_keys = translation_keys
          @mandatory_language = mandatory_language
        end

        def render
          ERB.new(template, nil, '-').result(binding)
        end

        def template
          raise NotImplementedError, 'Abstract Method'
        end

        def save(_path)
          raise NotImplementedError, 'Abstract Method'
        end
      end
    end
  end
end
